# Security Policy

## Supported Versions

We currently support the code running on the "main" branch and "development" branch of this repository. This is supported in addition to those formal releases, but note anything not yet released should be treated as in-development.

In terms of plugin releases, our support matrix is as follows:

### Actively Supported
These versions are currently actively supported by our team, and you should expect security patches where appropriate for these versions. 

| Version             | Supported  | Support End:                   |
| ------------------- | ---------- | ------------------------------ |
| 2022.02             | ✅         | No Earlier than May 2022       |

### Legacy Supported
These versions are no longer under active development, however we will look to release critical secuirty patches where appropriate. 

| Version             | Supported  | Support End: |
| ------------------- | ---------- | ------------ |
| 2021.09             | ⚠️         | April 2022   |


### No Longer Supported
These versions are no longer supported at all. It is strongly advised to update if you are running any of these versions. 

| Version             | Supported          | Support Ended:      |
| ------------------- | ------------------ | ------------------- |
| 2021.06             | :x:                | October 2021        |
| 2021.05             | :x:                | September 2021      |
| 2021.04             | :x:                | July 2021           |
| 2021.02             | :x:                | 6 June 2021         |
| 2020.11             | :x:                | 3 May 2021          |
| 6.0.x (Pre-Release) | :x:                | December 2020       |
| < 2020.11           | :x:                | December 2020       |
| < 5.x               | :x:                | December 2020       |

## Reporting a Vulnerability

If the report has minor security implications (ie we've added a super admin to a senior admins permission) please raise an post on [our forums](https://forum.totalfreedom.me/) in the first instance. If you do not have a forum account and do not wish to sign up, please e-mail us using the e-mail in the next sentence.

For security vulnerabilities that are more severe and that may pose a more significant threat to the servers running this plugin, please e-mail os-security-reports [ AT ] atlas-media.co.uk - You can expect an automated response immediately to acknowledge receipt of your e-mail, and one of our team will aim to respond within 72 hours and will work with you on the best way to address your concerns.
